// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_airskin_msgs:msg/AirskinColors.idl
// generated code does not contain a copyright notice

#ifndef TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__STRUCT_HPP_
#define TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'colors'
#include "std_msgs/msg/detail/color_rgba__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_airskin_msgs__msg__AirskinColors __attribute__((deprecated))
#else
# define DEPRECATED__tuw_airskin_msgs__msg__AirskinColors __declspec(deprecated)
#endif

namespace tuw_airskin_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AirskinColors_
{
  using Type = AirskinColors_<ContainerAllocator>;

  explicit AirskinColors_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit AirskinColors_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _idx_type =
    std::vector<uint16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint16_t>>;
  _idx_type idx;
  using _colors_type =
    std::vector<std_msgs::msg::ColorRGBA_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std_msgs::msg::ColorRGBA_<ContainerAllocator>>>;
  _colors_type colors;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__idx(
    const std::vector<uint16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint16_t>> & _arg)
  {
    this->idx = _arg;
    return *this;
  }
  Type & set__colors(
    const std::vector<std_msgs::msg::ColorRGBA_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std_msgs::msg::ColorRGBA_<ContainerAllocator>>> & _arg)
  {
    this->colors = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_airskin_msgs__msg__AirskinColors
    std::shared_ptr<tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_airskin_msgs__msg__AirskinColors
    std::shared_ptr<tuw_airskin_msgs::msg::AirskinColors_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AirskinColors_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->idx != other.idx) {
      return false;
    }
    if (this->colors != other.colors) {
      return false;
    }
    return true;
  }
  bool operator!=(const AirskinColors_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AirskinColors_

// alias to use template instance with default allocator
using AirskinColors =
  tuw_airskin_msgs::msg::AirskinColors_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_airskin_msgs

#endif  // TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_COLORS__STRUCT_HPP_
