// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_airskin_msgs:msg/AirskinInfo.idl
// generated code does not contain a copyright notice

#ifndef TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_INFO__STRUCT_HPP_
#define TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_airskin_msgs__msg__AirskinInfo __attribute__((deprecated))
#else
# define DEPRECATED__tuw_airskin_msgs__msg__AirskinInfo __declspec(deprecated)
#endif

namespace tuw_airskin_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AirskinInfo_
{
  using Type = AirskinInfo_<ContainerAllocator>;

  explicit AirskinInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit AirskinInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _ids_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _ids_type ids;
  using _names_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _names_type names;
  using _min_type =
    std::vector<uint32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint32_t>>;
  _min_type min;
  using _max_type =
    std::vector<uint32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint32_t>>;
  _max_type max;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__ids(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->ids = _arg;
    return *this;
  }
  Type & set__names(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->names = _arg;
    return *this;
  }
  Type & set__min(
    const std::vector<uint32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint32_t>> & _arg)
  {
    this->min = _arg;
    return *this;
  }
  Type & set__max(
    const std::vector<uint32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint32_t>> & _arg)
  {
    this->max = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_airskin_msgs__msg__AirskinInfo
    std::shared_ptr<tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_airskin_msgs__msg__AirskinInfo
    std::shared_ptr<tuw_airskin_msgs::msg::AirskinInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AirskinInfo_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->ids != other.ids) {
      return false;
    }
    if (this->names != other.names) {
      return false;
    }
    if (this->min != other.min) {
      return false;
    }
    if (this->max != other.max) {
      return false;
    }
    return true;
  }
  bool operator!=(const AirskinInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AirskinInfo_

// alias to use template instance with default allocator
using AirskinInfo =
  tuw_airskin_msgs::msg::AirskinInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_airskin_msgs

#endif  // TUW_AIRSKIN_MSGS__MSG__DETAIL__AIRSKIN_INFO__STRUCT_HPP_
